      implicit none
      integer maxn, n, nin, nout, ioptns, ifail, inform, iter, j
      parameter (maxn = 1000, n = 1000, nin = 5, nout = 6, ioptns = nin)
      double precision objf, rj, objgrd(n), user(1), work(13*n), x(n)
      integer iuser(1), iwork(n+1)
      external e04dgf, e04dkf, objfun, x04abf
c
      call x04abf(1,nout)
c                           x = alkuarvaus ratkaisulle
      do 10 j = 1, n-1, 2
         rj = j
         x( j ) = - 1.2d0 - 0.1d0*cos(rj)
         x(j+1) = 1.d0  + 0.1d0*cos(rj)
 10   continue
c                           Parametrit ratkaisurutiinille
      call e04dkf('   Maximum step length = 100')
      call e04dkf('   Optimality tolerance = 1.0d-14')
      call e04dkf('   Iteration limit = 1000')
      call e04dkf('   Print level = 1')
c                           Ratkaistaan ongelma
      ifail = -1
      call e04dgf(n, objfun, iter, objf, objgrd, x, iwork, work, iuser, 
     %            user, ifail)
c
      write (nout,*) 'Minimiarvo: ', objf
      stop
      end
c                           Minimoitava funktio ja gradienttivektori
      subroutine objfun(mode, n, x, objf, objgrd, nstate, iuser, user)
      implicit none
      integer mode, n, nstate, j, iuser(*)
      double precision objf, objgrd(n), user(*), x(n)
      double precision  t1, t2
c                           Kohdefunktion arvo
      objf = 0.d0
      do 10 j = 1, n-1, 2
         t1 =  1.d0 - x(j)
         t2 = 10.d0 * ( x(j+1) - x(j)**2 )
         objf = objf + (t1**2) + (t2**2)
 10   continue
c                           Gradienttivektori
      do 20 j = 1, n-1, 2
         t1 =  1.d0 - x(j)
         t2 = 10.d0 * ( x(j+1) - x(j)**2 )
         objgrd(j+1) =  20.d0 * t2
         objgrd( j ) =  -2.d0 * ( x(j) * objgrd(j+1) + t1 )
 20   continue
      return
      end

      implicit none
      integer m, n, lwork, i, j
      parameter (m = 6, n = 2, lwork = 2*m)
      integer info
      double precision a(m,m), tau(min(m,n)), work(lwork)
c
      data ((a(i,j),i =1,m), j = 1,n) / 1, 0, 1, 0, 1, 0, 0, 1, 0, 1, 0, 1 /
c
      call dgeqrf(m, n, a, m, tau, work, lwork, info)
      call dorgqr(m, m, min(m,n), a, m, tau, work, lwork, info)
c
      write (6,998) ((a(i,j), i = 1,m), j = 1,m)
 998  format ('a(i,j) = ', 6(2x,f8.6))
c
      end

      subroutine info(ip,icon,xst)
      implicit none
      integer ip, icon, n, ntot, ngloba, numrun
      double precision xst(80)
      common /eq/ n, ntot
      common /nacc/ ngloba 
      common /numrun/ numrun
      data n, ntot, numrun, ngloba / 2, 2, 0, 0 /
      ip = 0
      icon = 0
      write(6,9999) n, ntot
 9999 format(' Vapaita muuttujia ',i3,/, ' Muuttujia ',i3)
      return
      end
c                Kohdefunktio
      subroutine foptim(x,f)
      implicit none
      double precision x(80), f
      f = - 3*(1-x(1))**2*exp(-(x(1)**2) - (x(2)+1)**2)
     %     + 10*(x(1)/5 - x(1)**3 - x(2)**5)*exp(-x(1)**2-x(2)**2) 
     %     + 1/3*exp(-(x(1)+1)**2 - x(2)**2)
      return
      end
c                Epayhtalorajoitteet
      subroutine constr(x,n,kfail)
      implicit none
      integer n, kfail
      double precision x(80), xlow(80), xupp(80)
      common /range/ xlow, xupp
      kfail = 0
      xlow(1) = -100d0
      xupp(1) = 100d0
      xlow(2) = -100d0
      xupp(2) = 100d0
      return
      end
c                Yhtalorajoitteet
      subroutine equal(x,kfail)
      implicit none
      double precision x(80)
      integer kfail
      kfail = 0
      return
      end

      implicit none
      integer n, i, maxfcn, nout
      parameter (n = 2)
      real ftol, fx, s, x(n), x0(n)
      external fcn, umpol, umach
c
      do i = 1, n-1, 2
         x0(i) = -1.2d0
         x0(i+1) = 1.0d0
      end do
c
      ftol = 1.0d-10
      maxfcn = 1000*n**2
      s = 1.0
c
      call umpol(fcn, n, x0, s, ftol, maxfcn, x, fx)
c
      call umach(2, nout)
      write (nout, 998) (x(i), i=1,n)
      write (nout, 999) fx, maxfcn
 998  format ('x =  ', 8(2x,f10.6))
 999  format ('fx =   ', f10.6, ', iter = ', i4)
c
      end
c                             Minimoitava funktio
      subroutine fcn(n, x, f)
      implicit none
      integer n, j
      real x(n), f, t1, t2
      f = 0.d0
      do 10 j = 1, n-1, 2
         t1 = 1.d0 - x(j)
         t2 = 10.d0 * ( x(j+1) - x(j)**2 )
         f = f + (t1**2) + (t2**2)
 10   continue
      return
      end

      implicit none
      integer n, nclin, ncnln, nctotl, nrowa, nrowj, nrowr, liwork, lwork
      parameter (n = 2, nclin = 1, ncnln = 1, nctotl = n+nclin+ncnln, 
     %     nrowa = nclin, nrowj = ncnln, nrowr = n, liwork = 3*n+nclin+2*ncnln,
     %     lwork = 2*n*n+n*nclin+2*n*ncnln+20*n+11*nclin+21*ncnln )
      double precision bigbnd, epsaf, epsmch, eta, ftol, objf, rteps
      integer i, ifail, iter, itmax, j, mode, msglvl, nstate, nout
      data nout, nstate, mode, ifail, msglvl / 6, 1, 1, 1, 1 /
      data bigbnd, itmax, eta / 1.0d10, 100, 0.9d0 /
      logical cold, fealin, orthog
      data cold, fealin, orthog / .true., .true., .true. /
      double precision a(nrowa,n), bl(nctotl), bu(nctotl), c(nrowj),
     %                 cjac(nrowj,n), clamda(nctotl), featol(nctotl),
     %                 objgrd(n), r(nrowr,n), work(lwork), x(n)
c                  Alkuarvoja, lineaariset rajoitteet seka yla- ja alarajat
      data x / 2.0d0, 2.0d0 /, a / 1, -2 /
      data bl / -10.0d0, -5.0d0, -1.0d0, -1.0d0 /
      data bu / 10.0d0, 5.0d0, -1.0d0, 1.0d10 /
      integer istate(nctotl), iwork(liwork)
      double precision x02ajf
      external x02ajf, confun, e04vcf, e04zcf, objfun, x04abf
c                  Tarkistetaan gradientit
      ifail = 1
      call e04zcf(n, nclin, nrowj, confun, objfun, c, cjac, objf, objgrd, x, 
     %     work, lwork, ifail)
      if (ifail.eq.0) then
         write (nout, *) 'Gradienttivektori ok'
c                  Selvitetaan laskentatarkkuus
         epsmch = x02ajf()
         ftol = 10.0d0*epsmch
         rteps = sqrt(epsmch)
         do 20 j = 1, nctotl
            featol(j) = rteps
 20      continue
         call objfun(mode, n, x, objf, objgrd, nstate)
         epsaf = epsmch*abs(objf)
c                  Ratkaistaan tehtava
         ifail = 1
         call e04vcf(itmax, msglvl, n, nclin, ncnln, nctotl, nrowa, nrowj, 
     %        nrowr, bigbnd, epsaf, eta, ftol, a, bl, bu, featol, confun, 
     %        objfun, cold, fealin, orthog, x, istate, r, iter, c, cjac, 
     %        objf, objgrd, clamda, iwork, liwork, work, lwork, ifail)
         if (ifail.ne.0) write (nout, 99998) 'e04vcf:n virhe. ifail =', ifail
      else
         write (nout, 99998) 'Virhe gradienttivektorissa. ifail =', ifail
      end if
99998    format (1x,a,i3)
      stop
      end

      implicit none
      integer n, nsuc, iprint, nfev, iout
      parameter (n = 2)
      double precision x0(n), xmin(2), fmin
      data x0 / 0.0d0, 0.0d0 /
      nsuc = 3
      iprint = 0
      call sigma1(n,x0,nsuc,iprint,xmin,fmin,nfev,iout)
      stop
      end
c                     Kohdefunktio
      double precision function funct (n,x)
      double precision x(n)
      funct = - 3*(1-x(1))**2*exp(-(x(1)**2) - (x(2)+1)**2)
     %     + 10*(x(1)/5 - x(1)**3 - x(2)**5)*exp(-x(1)**2-x(2)**2) 
     %     + 1/3*exp(-(x(1)+1)**2 - x(2)**2)
      return
      end

c                  Kohdefunktio ja gradienttivektori
      subroutine objfun(mode,n,x,objf,objgrd,nstate)
      implicit none
      double precision objf
      integer mode, n, nstate
      double precision  objgrd(n), x(n)
c
      objf = (x(1)-2.0d0)**2 + (x(2)-1.0d0)**2
c
      objgrd(1) = 2.0d0*(x(1)-2.0d0)
      objgrd(2) = 2.0d0*(x(2)-1.0d0)
      return
      end
c                  Rajoitteet ja Jacobin matriisi
      subroutine confun(mode,ncnln,n,nrowj,x,c,cjac,nstate)
      implicit none
      integer mode, n, ncnln, nrowj, nstate
      double precision c(nrowj), cjac(nrowj,n), x(n)
      integer i, j
c                  Alustetaan Jacobin matriisi
      if (nstate.eq.1) then
         do 40 j = 1, n
            do 20 i = 1, ncnln
               cjac(i,j) = 0.0d0
   20       continue
   40    continue
      end if
c                  Epalin. rajoite 1
      c(1) = -(x(1)**2)/4.0d0 - x(2)**2
c                  Jacobin matriisin rivi 1
      cjac(1,1) = -0.5d0*x(1)
      cjac(1,2) = -2.0d0*x(2)
      return
      end

      implicit none
      integer n, nrhs, lwork, i, j
      parameter (n = 2, nrhs = 1, lwork = n*n)
      character uplo
      integer info, ipiv(n)
      double precision x(n), fx, gx(n), hx(n,n)
      double precision xdiff, xtol, work(lwork)
      data x / -1.2, 1.0 /, uplo / 'u' /, xdiff / 1.0 /, xtol / 10e-8 /
c
      j = 0
      do while (xdiff .gt. xtol)
         call derivfn(x, n, fx, gx, hx)
c                     Ratkaistaan Newton-yhtalo Lapackilla
         call dsysv(uplo, n, nrhs, hx, n, ipiv, gx, n, work, lwork, info)
         if (info .ne. 0) then
            if (info .gt. 0) print *, 'Hessen matriisi singulaarinen'
            stop
         end if
         xdiff = 0
         do i = 1, n
            x(i) = x(i) - gx(i)
            xdiff = xdiff + gx(i)**2
         end do
         xdiff = sqrt(xdiff)
         j = j + 1
      end do
c
      write(6, 999) (x(i), i=1,n), fx, j
 999  format('x = (', 2(2x,f8.6), ' ), fx = ', e12.6, ', j = ', i2)
      end
c                     Minimoitava kohdefunktio derivaattoineen
      subroutine derivfn(x, n, fx, gx, hx)
      implicit none
      integer n
      double precision x(n), fx, gx(n), hx(n,*)
c                     Funktion arvo
      fx = 100*(x(2) - x(1)**2)**2 + (1 - x(1))**2
c                     Gradienttivektori
      gx(1) = - 400*x(1)*(x(2) - x(1)**2) + 2*(x(1) - 1)
      gx(2) = 200*(x(2) - x(1)**2)
c                     Hessen matriisin ylakolmio
      hx(1,1) = 1200*x(1)**2 - 400*x(2) + 2
      hx(1,2) = - 400*x(1)
      hx(2,2) = 200
c
      end

      implicit   none
      integer    n
      parameter  (n=2)
c
      integer    i, maxfcn, nout
      real       ftol, fx, s, x(n), x0(n)
      external   fcn, dumpol, umach
c
      data x0 / -1.2, 1.0 /
c
      ftol   = 1.0e-10
      maxfcn = 200
      s      = 1.0
c
      call umpol(fcn, n, x0, s, ftol, maxfcn, x, fx)
c
      call umach(2, nout)
      write (nout, 999) (x(i), i=1,n), fx
999   format ('x = (', 2(2x,f4.2), '), fx = ', e12.6)
c
      end
c                             Minimoitava funktio
      subroutine fcn(n, x, f)
      integer  n
      real     x(n), f
      f = 100.0*(x(1)*x(1)-x(2))**2 + (1.0-x(1))**2
      return
      end

c                         Kohdefunktio
      subroutine funobj(mode, n, x, f, g, nstate, nprob, z, nwcore)
      implicit none
      integer n, nstate, nprob, nwcore
      double precision x(n), f, g(n), z(nwcore), t1, t2, t3, t4, t5
c                        Funktion arvo
      t1 = x(1) - 1.0
      t2 = x(1) - x(2)
      t3 = x(2) - x(3)
      t4 = x(3) - x(4)
      t5 = x(4) - x(5)
      f = t1**2 + t2**2 + t3**3 + t4**4 + t5**4
c                        Gradienttivektori
      g(1) = 2.0*(t1 + t2)
      g(2) = -2.0*t2 + 3.0*t3**2
      g(3) = -3.0*t3**2 + 4.0*t4**3
      g(4) = -4.0*t4**3 + 4.0*t5**3
      g(5) = -4.0*t5**3
c
      return
      end
c                         Rajoitusehdot
      subroutine funcon(mode, m, n, njac, x, f, g, nstate, 
     %     nprob, z, nwcore)
      implicit none
      integer m, n, njac, nstate, nprob, nwcore
      double precision x(n), f(m), g(m,n), z(nwcore)
c                        Rajoitusehto 1
      f(1) = x(1) + x(2)**2 + x(3)**3
      g(1,1) = 1.0
      g(1,2) = 2.0*x(2)
      g(1,3) = 3.0*x(3)**2
c                        Rajoitusehto 2
      f(2) = x(2) - x(3)**2 + x(4)
      g(2,2) = 1.0
      g(2,3) = -2.0*x(3)
      g(2,4) = 1.0
c                        Rajoitusehto 3
      f(3) = x(1)*x(5)
      g(3,1) = x(5)
      g(3,5) = x(1)
c
      return
      end
